import { Either } from 'fp-ts/lib/Either';
import { FantasyMonad } from 'fp-ts/lib/Monad';
import { Option } from 'fp-ts/lib/Option';
import { Task } from 'fp-ts/lib/Task';
declare module 'fp-ts/lib/HKT' {
    interface HKT<A, U> {
        'Task . Either': Task<Either<U, A>>;
        TaskEither: TaskEither<U, A>;
    }
}
export declare const URI = "TaskEither";
export declare type URI = typeof URI;
export declare class TaskEither<L, A> implements FantasyMonad<URI, A> {
    readonly value: Task<Either<L, A>>;
    readonly _L: L;
    readonly _A: A;
    readonly _URI: URI;
    constructor(value: Task<Either<L, A>>);
    run(): Promise<Either<L, A>>;
    map<B>(f: (a: A) => B): TaskEither<L, B>;
    of<L2, B>(b: B): TaskEither<L2, B>;
    ap<B>(fab: TaskEither<L, (a: A) => B>): TaskEither<L, B>;
    chain<B>(f: (a: A) => TaskEither<L, B>): TaskEither<L, B>;
    fold<R>(left: (l: L) => R, right: (a: A) => R): Task<R>;
    mapLeft<L2>(f: (l: L) => L2): TaskEither<L2, A>;
    toOption(): Task<Option<A>>;
}
export declare function map<L, A, B>(f: (a: A) => B, fa: TaskEither<L, A>): TaskEither<L, B>;
export declare function of<L, A>(a: A): TaskEither<L, A>;
export declare function ap<L, A, B>(fab: TaskEither<L, (a: A) => B>, fa: TaskEither<L, A>): TaskEither<L, B>;
export declare function chain<L, A, B>(f: (a: A) => TaskEither<L, B>, fa: TaskEither<L, A>): TaskEither<L, B>;
export declare function right<L, A>(ma: Task<A>): TaskEither<L, A>;
export declare function left<L, A>(ml: Task<L>): TaskEither<L, A>;
