"use strict";
// tslint:disable-next-line max-line-length
// https://github.com/gcanti/fp-ts/blob/4ef68b556576ca48d5b0042c9fe9b7cf67375b66/examples/TaskEither.ts
Object.defineProperty(exports, "__esModule", { value: true });
const EitherT_1 = require("fp-ts/lib/EitherT");
const task = require("fp-ts/lib/Task");
const eitherTTask = EitherT_1.getEitherT('Task . Either', task);
exports.URI = 'TaskEither';
class TaskEither {
    constructor(value) {
        this.value = value;
    }
    run() {
        return this.value.run();
    }
    map(f) {
        return new TaskEither(eitherTTask.map(f, this.value));
    }
    of(b) {
        return of(b);
    }
    ap(fab) {
        return new TaskEither(eitherTTask.ap(fab.value, this.value));
    }
    chain(f) {
        return new TaskEither(eitherTTask.chain(a => f(a).value, this.value));
    }
    fold(left, right) {
        return eitherTTask.fold(left, right, this.value);
    }
    mapLeft(f) {
        return new TaskEither(eitherTTask.mapLeft(f, this.value));
    }
    toOption() {
        return eitherTTask.toOption(this.value);
    }
}
exports.TaskEither = TaskEither;
function map(f, fa) {
    return fa.map(f);
}
exports.map = map;
function of(a) {
    return new TaskEither(eitherTTask.of(a));
}
exports.of = of;
// tslint:disable-next-line max-line-length
function ap(fab, fa) {
    return fa.ap(fab);
}
exports.ap = ap;
// tslint:disable-next-line max-line-length
function chain(f, fa) {
    return fa.chain(f);
}
exports.chain = chain;
function right(ma) {
    return new TaskEither(eitherTTask.right(ma));
}
exports.right = right;
function left(ml) {
    return new TaskEither(eitherTTask.left(ml));
}
exports.left = left;
//# sourceMappingURL=TaskEither.js.map