"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const array = require("fp-ts/lib/Array");
const either = require("fp-ts/lib/Either");
const option = require("fp-ts/lib/Option");
const t = require("io-ts");
const src_1 = require("io-ts-reporters/target/src");
const parseNumber = (s) => {
    const n = parseFloat(s);
    return isNaN(n) ? option.zero() : option.some(n);
};
exports.NumberFromString = t.prism(t.string, parseNumber, 'NumberFromString');
exports.JSONFromString = t.prism(t.string, s => either.tryCatch(() => JSON.parse(s)).toOption(), 'JSONFromString');
exports.composeTypes = (fa, fb, name) => new t.Type(name, (v, c) => fa.validate(v, c).chain(a => fb.validate(a, c)));
exports.formatValidationErrors = (validationErrors) => array.catOptions(validationErrors.map(src_1.formatValidationError));
//# sourceMappingURL=other.js.map